#include <stdio.h>
#include <inttypes.h>

int bit_count( uint32_t v )
{
	uint32_t sum;
	for( sum = 0; v; v>>=1 )
		sum += v & 1;
	return sum;
}

int bit_count_kr( uint32_t v )
{
	uint32_t sum;
	for( sum = 0; v; sum++ )
		v &= v - 1; /* clear right most bit set */
	return sum;
}

int main() {

	printf( "bc:    0x0000 -> %d\n", bit_count( 0x0000 ) );
	printf( "bc_kr: 0x0000 -> %d\n", bit_count_kr( 0x0000 ) );

	printf( "bc:    0x00F0 -> %d\n", bit_count( 0x00F0 ) );
	printf( "bc_kr: 0x00F0 -> %d\n", bit_count_kr( 0x00F0 ) );
	
	printf( "bc:    0x10F0 -> %d\n", bit_count( 0x10F0 ) );
	printf( "bc_kr: 0x10F0 -> %d\n", bit_count_kr( 0x10F0 ) );
	
	return 0;
}
